// ==UserScript==
// @name            【懒盘】百度网盘-蓝奏网盘自动填写密码[抓取&服务器] - 替代云盘精灵
// @description	    百度网盘，蓝奏网盘自动填取提取码。抓取前一页面的提取码，或从服务器获取该网盘的提取码并尝试自动填写密码和跳转。自动激活页面网盘链接，不用手动复制访问。
// @author			无道
// @namespace       https://www.lzpan.com
// @version			1.1.0
// @date            2019.09.24
// @modified		2019.10.12
//
// 支持的网盘
// @include			http*://pan.baidu.com/s/*
// @include			http*://pan.lanzou.com/*
// @include         http*://www.lanzous.com/*
// @include         http://*
// @include			https://*
//
// 白名单
// @exclude			http*://*.pcs.baidu.com/*
// @exclude			http*://*.baidupcs.com/*
// @exclude			http*://*:8666/file/*
// @exclude			http*://index.baidu.com/*
//
// @exclude			http*://*.gov/*
// @exclude			http*://*.gov.cn/*
// @exclude			http*://*.taobao.com/*
// @exclude			http*://*.tmall.com/*
// @exclude			http*://*.alimama.com/*
// @exclude			http*://*.bilibili.com/*
// @exclude			http*://*.jd.com/*
// @exclude			http*://*.zol.com.cn/*
// @exclude			http*://*.ctrip.com/*
// @exclude			http*://*.evernote.com/*
// @exclude			http*://*.yinxiang.com/*
// @exclude         http*://mail.*
// @exclude         http*://ping.*
// @exclude         http*://inbox.google.com/*
// @exclude			/^https?://(localhost|10\.|192\.|127\.)/
// @exclude			/https?://www.baidu.com/(?:s|baidu)\?/
// @exclude			http*://www.zhihu.com/question/*/answers/created
// require			http://code.jquery.com/jquery-2.1.4.min.js
// @require			http://cdn.staticfile.org/jquery/2.1.4/jquery.min.js
// @require         https://greasyfork.org/scripts/35940-my-jquery-plugin/code/My%20jQuery%20Plugin.js?version=234478
// @icon            https://www.lzpan.com/apple-touch-icon.png
// @note            2019年10月11日16:40:52 修复@尽量公开 网友反馈的不是以http://开头的网址，激活错误问题。自测已修复，请大家反馈。
// @note            2019年10月9日11:13:01 已知问题：由于每个网站页面不一样，激活不能点击的链接可能导致网站不能正常使用。
// @note            2019年10月9日11:13:01 排除B站中的问题，不然搜索无法换页。
// @note            2019年10月8日17:47:53 修复@shajia1992网友提出的网站不兼容问题。
// @note            2019年10月7日18:18:16 更新获取密码偶尔失败的问题!
// @note            2019年10月5日10:38:27 更新百度网盘获取大小偶尔失败!
// @grant           unsafeWindow
// @grant           GM_setValue
// @grant           GM_getValue
// @grant           GM_log
// @grant           GM_deleteValue
// @grant           GM_listValues
// @grant           GM_xmlhttpRequest
// @grant           GM_info
// @noframes
// @encoding		utf-8
// @run-at			document-idle
// ==/UserScript==

var $ = $ || window.$;
var urls = location.href; // 完整路径
var hash = location.hash;
var host = location.hostname.replace(/^www\./i, '').toLowerCase();
var search = location.search;
var paths = location.pathname.toLowerCase();

// console.log("urls", urls)
// console.log("host", host)
// GM_setValue('1TvWcCTtn-pjjhOxxVEP_4w', '');
// options
var options = {
    site: 0,
    info_start: "懒盘：",
    api_server: "https://www.lzpan.com/api",
    // api_server: "http://lzpan.misiyu.cn/api",
    // api_server: "http://lzpan.test/api",
}, input_aim_el = {
    "baidu": ".pickpw > .input-area > input",
    "lanzou": "#pwd",
    "lanzou2": "#pwd",
}, notice_aim_el = {
    "baidu": "#rebZkd",
    "lanzou": "#info",
    "lanzou2": "#pwderr",
}, click_aim_el = {
    "baidu": "#grmvE3Vo > a > span",
    "lanzou": "#passwddiv > div > div.passwddiv-input > div",
    "lanzou2": "#sub",

};

// library 
// ====== synthetic urls for regex
var syntheticUrls = function (urls) {
    var s = '';
    for (var i = 0; i < urls.length; i++) {
        s += urls[i] + "\n";
    }
    return s;
}
// ====== put the pass to localStorage
var deal_server_pass = function (res) {
    if (res.data.length === 1 && res.data[0].length >= 1) {
        // var tmp = res.data[0];
        for (const tmp in res.data[0]) {
            if (res.data[0].hasOwnProperty(tmp)) {
                const element = res.data[0][tmp];
                GM_setValue(element.disk_id, element.pass);
            }
        }
        // GM_log(GM_getValue('ad') === '') true
        // GM_log(GM_getValue('fasdf')) 不存在 undefined
    }
}
// ====== match disk_id
var get_disk_id = function (url) {
    var matches;

    matches = /https?:\/\/pan\.baidu\.com\/share\/init\?surl=([a-zA-Z0-9_\-]{5,25})/ig.exec(url);
    if (matches && matches.length === 2) {
        return matches[1];
    }

    matches = /https?:\/\/pan\.baidu\.com\/s\/1([a-zA-Z0-9_\-]{5,25})/ig.exec(url);
    if (matches && matches.length === 2) {
        return matches[1];
    }


    matches = /https?:\/\/(?:www|pan)?\.lanzous?\.com\/([\w-_]{6,10})/ig.exec(url);
    if (matches && matches.length === 2) {
        return matches[1];
    }
    return null;
};


// ===== get pass 
var get_pass = function (disk_id, disk_type, success, fail) {
    var gm_pass = GM_getValue(disk_id);
    if (gm_pass) {
        // return gm_pass;
        success(gm_pass);
    } else {
        GM_xmlhttpRequest({
            url: options.api_server + '/getPass',
            synchronous: false,
            method: 'POST',
            data: 'disk_type=' + disk_type + '&disk_id=' + disk_id,
            headers: {
                "Content-type": "application/x-www-form-urlencoded"
            },
            onload: function (res) {
                res = JSON.parse(res.response);
                if (res && res.data[0].pass) {
                    GM_setValue(disk_id, res.data[0].pass);
                    success(res.data[0].pass);
                } else {
                    fail();
                }
            }
        });
    }

};

// === send pass to server
var send_url = function (type, text, href, title, un_pass) {
    GM_xmlhttpRequest({
        method: "POST",
        url: options.api_server + '/importTmpUrl',
        synchronous: true,
        headers: {
            "Content-type": "application/x-www-form-urlencoded"
        },
        data: 'type=' + type + '&text=' + text + '&href=' + encodeURIComponent(href) + '&title=' + title + '&un_pass=' + un_pass,
        onload: function (res) {
            // GM_log();
            deal_server_pass(JSON.parse(res.response));
        }
    });
};

// === send info
var send_info = function (file_name, file_size, file_ext, share_user, share_date, disk_type, disk_id, pass = '') {
    if (file_name.indexOf('base64,') === -1) {
        file_name = encodeURIComponent(file_name);
    }
    if (typeof pass === undefined || pass === '') {
        pass = '';
    }
    GM_xmlhttpRequest({
        method: "POST",
        url: options.api_server + '/importInfo',
        synchronous: true,
        headers: {
            "Content-type": "application/x-www-form-urlencoded"
        },
        data: 'file_name=' + file_name + '&share_date=' + share_date + '&file_ext=' + file_ext + '&file_size=' + file_size + '&share_user=' + share_user + '&disk_type=' + disk_type + '&disk_id=' + disk_id + '&pass=' + pass,
        onload: function (res) {
            GM_log('Sent Info');

        }
    });
}


// === send invalidate info
var send_invalidate_info = function (disk_id) {
    GM_xmlhttpRequest({
        method: "GET",
        url: options.api_server + '/updateState?state=0&disk_id=' + disk_id,
        synchronous: true,
        onload: function (res) {
            GM_log('Sent invalidate info');
        }
    });
};




// === send filelist info

var send_file_list = function (list, disk_id) {
    GM_xmlhttpRequest({
        method: "POST",
        headers: {
            "Content-type": "application/x-www-form-urlencoded"
        },
        url: options.api_server + '/importFileList',
        synchronous: true,
        data: 'list=' + encodeURIComponent(list) + '&disk_id=' + disk_id,
        onload: function (res) {
            GM_log('Sent file list');
        }
    });
};

// === active link
var activelink = function (re, nre) {

    if (active_ex_hosts.test(host)) return; // 屏蔽错误网站

    $('body > div').each(function () {
        //console.log('info:'+ $(this).html()); // .t_f
        // var link = re.exec($(this).html());
        if (($(this).html()).match(nre)) return;
        var link = ($(this).html()).match(re);
        // console.log(link);
        if (link) {
            var ss = $(this).html();
            var s = re.exec(ss);
            if (s && s[0] && !/^https?:\/\//ig.test(s[0])) {
                ss = ss.replace(re, '<a target="_blank" href="http://$1" style="padding: 0 1px;color: rgb(232, 67, 147); text-decoration:none; border: 1px solid">$1</a>');
            } else {
                ss = ss.replace(re, '<a target="_blank" href="$1" style="padding: 0 1px;color: rgb(232, 67, 147); text-decoration:none; border: 1px solid">$1</a>');
            }
            $(this).html(ss);
        }
    });
}

// === put file list
var get_file_list = function (disk_id) {
    hash = '##';
    var new_hash = '';
    var file_list = [];
    var hash_timer = setInterval(function () {
        new_hash = location.hash;
        if (new_hash !== hash) {
            hash = new_hash;
            setTimeout(function () {
                var filename = $("div > div > dd div.file-name > div.text > a");
                var filesize = $("div > div > dd > div.file-size");
                filename.map(function (index, dom) {
                    file_list.push({ "name": dom.innerText, "size": filesize[index].innerText });
                });

                // GM_log(JSON.stringify(file_list));
                var list = JSON.stringify(file_list);
                send_file_list(list, disk_id);
                // clearInterval(hash_timer);
                // GM_log('new_hash', new_hash)
            }, 1000);
        }
    }, 2000);
}

// some regular expression
var reg_site_patterns = {
    // host
    "lanzou": /(www|pan)?\.?lanzous?\.com$/igm,
    "baidu_pwd": /pan\.baidu\.com\/share\/init\?surl/ig,
    "baidu": /pan\.baidu\.com$/igm,
}, unPWArr = [
    /password[:： ]?([^\n]+)/igm,
    /解压[:： ]?(\w+)/gm,
    /【解压密码】\s*[:： ]?\s*([^\n]+)/igm,
    /\[解压密码\]\s*[:： ]?\s*([a-z\d\.:/@]+)/igm,
    /(?:解[压壓]密?[码碼])\s*[:： ]?\s*([a-z\d\.:/@]+)/igm,
    /(?:解[压壓]密?[码碼])(?:都?是|为)?\s*[:： ]?\s*([\w\.:/@]+)[^$\r\n]/igm,
    /(?:[解激][活压壓]密?[码碼])(?:都?是|为)?\s*[:： ]?\s*([^\w]+)[^$\r\n]/igm, //中文类
    /【?压缩密码】?\s*[:： ]?\s*([^\n]+)/igm,
    /【?[資资]源密[码碼]】?：(\w+)/
], invalidate_regex = {
    "baidu": /(被取消了|分享文件已过期|已经被删除|分享内容可能因为|啊哦，你来晚了|取消分享了)/ig,
    "lanzou": /(被取消了|分享文件已过期|已经被删除|分享内容可能因为|啊哦，你来晚了|取消分享了)/ig,
}, active_ex_hosts = /(qiuziyuan\.net)/ig;


var get_unPW = function () {
    var unPWAString = '';
    for (var i = 0; i < unPWArr.length; i++) {
        var matches = unPWArr[i].exec(document.body.innerText);
        if (matches && matches.length >= 2) {
            if (unPWAString.indexOf(matches[1]) === -1) {
                unPWAString += matches[1] + "\n";
            }
        }
    }
    return unPWAString;
}


var disk_id = '';
var pass = '';
var un_pass = '';
var is_send = false;


var file_name = '';
var file_size = '';
var share_user = '';
var share_date = '';
var file_ext = '';


var el_input = null;
var el_click = null;
var el_notice = null;
if (reg_site_patterns.lanzou.test(host)) {// 是蓝奏网盘
    options.site = 0;
    // console.log('蓝奏网盘')
    disk_id = get_disk_id(urls);
    var passwddiv = $("#passwddiv");
    var pwdload = $("#pwdload");
    //pwd1
    if (passwddiv.length !== 0 && passwddiv.css('display') !== 'none') {
        console.log('wait for search&input password > pwd1 > passwddiv');

        el_input = $(input_aim_el.lanzou);
        el_click = $(click_aim_el.lanzou);
        el_notice = $(notice_aim_el.lanzou);
        get_pass(disk_id, 'LZY', function (pass) {
            el_notice.show().text(options.info_start + "已找到密码，将自动填入")
            el_input.val(pass);
            el_click.click();
        }, function () {
            el_notice.show().text(options.info_start + "未找到密码，请输入")
        });

        el_input.on('input', function (t) {
            var value = t.target.value;
            GM_setValue(disk_id, value);
        });

    } else if (pwdload.length !== 0 && pwdload.css('display') !== 'none') {
        // pwd2

        el_input = $(input_aim_el.lanzou2);
        el_click = $(click_aim_el.lanzou2);
        el_notice = $(notice_aim_el.lanzou2);
        console.log('wait for search&input password > pwd2');
        get_pass(disk_id, 'LZY', function (pass) {
            el_notice.show().text(options.info_start + "已找到密码，将自动填入")
            el_input.val(pass);
            el_click.click();
        }, function () {
            el_notice.show().text(options.info_start + "未找到密码，请输入");
        });

        el_input.on('input', function (t) {
            var value = t.target.value;
            GM_setValue(disk_id, value);
        });

    }
    var l_one_timer = null;
    var l_two_timer = null;
    // this is one
    l_one_timer = setInterval(function () {
        if (!is_send) {
            file_name = $("body > div.d > div.b").text() || document.title;
            // GM_log(file_name)
            // var lz_match = /文件大小：(.+)[\s\n]+上传时间：.+?[\s\n]+分享用户：(.+)/ig.exec(document.body.innerText);
            // GM_log(lz_match)
            var lz_file_size_match = /文件大小[:：]?(.+)/ig.exec(document.body.innerText);
            file_size = lz_file_size_match[1] || '';
            var lz_share_user_match = /分享用户[:：]?(.+)/ig.exec(document.body.innerText);
            share_user = lz_share_user_match[1] || '';
            if (file_name && file_size && share_user) {
                is_send = true;
                clearInterval(l_one_timer);
                clearInterval(l_two_timer);
                GM_log('send info one');
                send_info(file_name, file_size, '', share_user, '', 'LZY', disk_id, GM_getValue(disk_id));
            }
        } else {
            clearInterval(l_one_timer);
        }

    }, 1000);
    // this is two

    l_two_timer = setInterval(function () {
        if (!is_send) {
            file_name = $("#filenameajax").text();
            file_size = $("#file > div.n_box > div.n_file > div.n_filesize").text().replace("大小：", "");
            share_user = $("#file > div.n_hd > div > span.user-name").text();
            if (file_name && file_size && share_user && (passwddiv.css('display') === 'none' || passwddiv.length === 0)) {
                is_send = true;
                clearInterval(l_one_timer);
                clearInterval(l_two_timer);
                GM_log('send info two');
                send_info(file_name, file_size, '', share_user, '', 'LZY', disk_id, GM_getValue(disk_id));
            }
        } else {
            clearInterval(l_two_timer);
        }

    }, 1000);



    // invalidate
    if (invalidate_regex.lanzou.test(document.body.innerText)) {
        send_invalidate_info(disk_id);
    }

} else if (reg_site_patterns.baidu.test(host)) {// 是百度网盘
    options.site = 1;
    // console.log('百度网盘')
    disk_id = get_disk_id(urls);

    //pwd
    if (reg_site_patterns.baidu_pwd.test(urls)) {
        console.log('wait for search&input password > BDY');

        el_input = $(input_aim_el.baidu);
        el_click = $(click_aim_el.baidu);
        el_notice = $(notice_aim_el.baidu);
        get_pass(disk_id, 'BDY', function (pass) {
            el_input.val(pass)
            el_notice.show().text(options.info_start + "已找到密码，尝试输入");
            el_click.click();
        }, function () {
            el_notice.show().text(options.info_start + "未找到密码，请输入");
        });

        el_input.on('input', function (t) {
            var value = t.target.value.replace("*", "");
            GM_setValue(disk_id, value);
        });

    } else {
        // real page
        file_size = $("#layoutMain > div.frame-content > div.module-share-header > div > div.slide-show-right > div > div > div.x-button-box >  span > span").text();
        share_date = $("div.module-share-header > div > div.slide-show-other-infos > div.share-file-info > span").text();
        share_user = $("div.module-share-person-info > div > div.share-person-data.self > div > a.share-person-username.global-ellipsis").text();
        file_name = $("div.module-share-header > div > div.slide-show-left > h2 > img").attr('src');
        // deal
        if (!file_name || typeof file_name === undefined) {
            file_name = $('#bd-main > div > div.module-share-header > div > div.slide-show-left > h2').text();
        }
        var bd_filesize = /下载\((.*?)\)/ig.exec(file_size);
        if (bd_filesize && bd_filesize[1]) {
            file_size = bd_filesize[1];
        }
        // GM_log(file_size);
        var ext_matches = /"path":"(\..*?)"/ig.exec(document.body.innerHTML);
        // GM_log(ext_matches);
        if (ext_matches && ext_matches[1]) {
            file_ext = ext_matches[1];
        }
        // GM_log('file_size', file_size)
        // GM_log('file_name', file_name)
        // GM_log('share_user', share_user)
        // GM_log('share_date', share_date)
        // GM_log('file_ext', file_ext)

        if (file_name && share_user && share_date) {
            send_info(file_name, file_size, file_ext, share_user, share_date, 'BDY', disk_id, GM_getValue(disk_id));
        }

        // invalidate
        if (invalidate_regex.baidu.test(document.body.innerText)) {
            send_invalidate_info(disk_id);
        }

        // hash - file list
        get_file_list(disk_id);
    }




} else { // other pages
    // 获取是否有网盘链接，并提取密码等。
    un_pass = get_unPW();
    // === baidu
    var result_urls = document.body.innerText.match(/((?:https?:\/\/)?(?:pan|yun)\.baidu\.com\/s\/[\w-_]{8,25})[^\w]*(?:密码|授权码|提取码)*(?:：|:)*[^\w]*([\w]{4})*/igm);
    if (result_urls && result_urls.length > 0) {
        // something
        var urls_text = syntheticUrls(result_urls);
        // GM_log(urls_text);
        send_url('BDY', urls_text, urls, document.title, un_pass);
    }
    // === lanzou
    var lanzou_result_urls = document.body.innerText.match(/((?:https?:\/\/)?(?:www|pan)?\.lanzous?\.com\/[\w-_]{6,10})\/?[^\w]*(?:密码|授权码|提取码)*(?:：|:)*[^\w]*([\w]{4})*/igm);
    if (lanzou_result_urls && lanzou_result_urls.length > 0) {
        // something
        var lanzou_urls_text = syntheticUrls(lanzou_result_urls);
        // GM_log(lanzou_urls_text);

        send_url('LZY', lanzou_urls_text, urls, document.title, un_pass);
    }

    // === active links
    var re_baidu = /((?:https?:\/\/)?(?:yun|pan|eyun).baidu.com\/(?:s\/[\w\-_]*|share\/\S*\d))/ig;
    var re_ex_baidu = /(href=["']?https?:\/\/(yun|pan|eyun).baidu.com\/(?:s\/[\w\-_]*|share\/\S*\d))/ig;
    activelink(re_baidu, re_ex_baidu);
    var re_lanzou = /((?:https?:\/\/)?(?:www|pan|).lanzous?.com\/[\w\-_]{6,10})/ig;
    var re_ex_lanzou = /(href=["']?https?:\/\/(www|pan).lanzous?.com\/[\w\-_]{6,10})/ig;
    activelink(re_lanzou, re_ex_lanzou);
}

// console.log("%c" + "Netdisk By 无道", "border: 1px solid #e74c3c;color: #2ecc71;font-size:16px;")
